package cn.iocoder.yudao.module.product.dal.mysql.envtype;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.product.controller.admin.envtype.vo.EnvTypeDeviceConfigRespVO;
import cn.iocoder.yudao.module.product.controller.admin.envtype.vo.EnvTypePageReqVO;
import cn.iocoder.yudao.module.product.dal.dataobject.envtype.EnvTypeDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 环境类型 Mapper
 *
 * @author 芋道源码
 */
@Mapper
public interface EnvTypeMapper extends BaseMapperX<EnvTypeDO> {

    default PageResult<EnvTypeDO> selectPage(EnvTypePageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<EnvTypeDO>()
                .likeIfPresent(EnvTypeDO::getEnvTypeName, reqVO.getEnvTypeName())
                .likeIfPresent(EnvTypeDO::getEnvFieldName, reqVO.getEnvFieldName())
                .eqIfPresent(EnvTypeDO::getRemarks, reqVO.getRemarks())
                .betweenIfPresent(EnvTypeDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(EnvTypeDO::getId));
    }

    List<EnvTypeDO> getAvailableEnvType(@Param("businessInfoId") Long businessInfoId);

    List<EnvTypeDeviceConfigRespVO> getEnvTypeConfigGroupByLandId(@Param("businessInfoId") Long businessInfoId);

}
